// File Name:
//		hardware.c
//
// Contents:
//		Routines to hide various hardware details
//

#include "xxdriver.h"

//
// Forward declarations of local routines
//
// (None)

//++
// Function:
//		XxInitializeHardware
//
// Description:
//		This function puts the hardware into a
//		known state.
//
// Arguments:
//		A pointer to a Device Extension
//
// Return Value:
//		Always TRUE
//
// Synchronization:
//		This function must be synchronized
//		with the ISR.
//
//--
BOOLEAN
XxInitializeHardware(
	PDEVICE_EXTENSION pDE
	)
{
	return TRUE;
}

//++
// Function:
//		XxEnableInterrupts
//
// Description:
//		This function turns on device interupts.
//		It expects to be synchronized with the
//		ISR.
//
// Arguments:
//		A pointer to a Device Extension
//
// Return Value:
//		Always TRUE
//--
BOOLEAN
XxEnableInterrupts(
	PDEVICE_EXTENSION pDE
	)
{
	return TRUE;
}

//++
// Function:
//		XxDisableInterrupts
//
// Description:
//		This function turns device interupts off.
//		It expects to be synchronized with the
//		ISR.
//
// Arguments:
//		A pointer to a Device Extension
//
// Return Value:
//		Always TRUE
//--
BOOLEAN
XxDisableInterrupts(
	PDEVICE_EXTENSION pDE
	)
{
	return TRUE;
}
