// File Name:
//		eventlog.h
//
// Contents:
//		Constants, structures, and function
//		declarations used for event logging.
//
#ifndef __XX_EVENTLOG__
#define __XX_EVENTLOG__

//
// Header files
//
#include <ntddk.h>

//
// Various constants
//
// Error-logging verbosity levels
//
#define LOG_LEVEL_NONE			0
#define LOG_LEVEL_NORMAL		1
#define LOG_LEVEL_DEBUG			2

#define  DEFAULT_LOG_LEVEL	LOG_LEVEL_DEBUG

//
// Unique values identifying location
// of an error within the driver 
//
#define XX_ERRORLOG_INIT				1
#define XX_ERRORLOG_DISPATCH			2
#define XX_ERRORLOG_STARTIO				3
#define XX_ERRORLOG_CONTROLLER_CONTROL	4
#define XX_ERRORLOG_ADAPTER_CONTROL		5
#define XX_ERRORLOG_ISR					6
#define XX_ERRORLOG_DPC_FOR_ISR			7
#define XX_ERRORLOG_UNLOAD				8

//
// Largest number of insertion strings
// allowed in one message
//
#define XX_MAX_INSERTION_STRINGS		20

//
// Prototypes for globally defined functions...
//
VOID
XxInitializeEventLog(
	IN PDRIVER_OBJECT DriverObject
	);

BOOLEAN
XxReportEvent(
	IN ULONG	MessageLevel,
	IN NTSTATUS	ErrorCode,
	IN ULONG	UniqueErrorValue,
	IN PVOID	IoObject,
	IN PIRP		Irp,
	IN ULONG	DumpData[],
	IN ULONG	DumpDataCount,
	IN PWSTR	Strings[],
	IN ULONG	StringCount
	);

#endif	// __XX_EVENTLOG__

