// File Name:
//		yydriver.h
//
// Contents:
//		Constants, structures, and function
//		declarations specific to this driver.
//
#ifndef __YY_DRIVER__
#define __YY_DRIVER__

//
// Header files
//
#include <ntddk.h>
#include <devioctl.h>

#include "..\inc\xxioctl.h"

//
// Various constants
//
#define	YY_DRIVER_NAME			L"YYDRIVER"
#define TARGET_DEVICE_NAME      L"\\Device\\Xx0"

//++
// Description:
//		Driver-defined structure used to hold 
//		miscellaneous device information.
//
// Access:
//		Allocated from NON-PAGED POOL
//		Available at any IRQL
//--
typedef struct _DEVICE_EXTENSION {
	PDEVICE_OBJECT DeviceObject; // Back pointer

	PDEVICE_OBJECT TargetDevice;
	XX_BUFFER_SIZE_INFO BufferInfo;	
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;


//
// Prototypes for globally defined functions...
//
// init.c
//
NTSTATUS
DriverEntry(
	IN PDRIVER_OBJECT DriverObject,
	IN PUNICODE_STRING RegistryPath
	);

//
// unload.c
//
VOID
YyDriverUnload(
	IN PDRIVER_OBJECT DriverObject
	);

//
// dispatch.c
//
NTSTATUS
YyDispatchWrite(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
	);

NTSTATUS
YyDispatchDeviceIoControl(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
	);

NTSTATUS
YyDispatchPassThrough(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
	);

//
// complete.c
//
NTSTATUS
YyGenericCompletion(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp,
	IN PVOID Context
	);

NTSTATUS
YyWriteCompletion(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp,
	IN PVOID Context
	);

#endif	// __YY_DRIVER__

