// File Name:
//		xxioctl.h
//
// Contents:
//		Definitions of IOCTL codes and data
//		structures exported by XXDRIVER.
//
#ifndef __XX_IOCTL__
#define __XX_IOCTL__

//
// Header files
//
// (None)

//
// Miscellaneous definitions
//
#define XX_NO_BUFFER_LIMIT	((ULONG)(-1))

//
// IOCTL control codes
//
#define IOCTL_XX_FUNCTION1					\
	CTL_CODE( FILE_DEVICE_UNKNOWN, 0x801,	\
		METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_XX_FUNCTION2					\
	CTL_CODE( FILE_DEVICE_UNKNOWN, 0x802,	\
		METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_XX_GET_MAX_BUFFER_SIZE		\
	CTL_CODE( FILE_DEVICE_UNKNOWN, 0x803,	\
		METHOD_BUFFERED, FILE_ANY_ACCESS )

//
// Structures used by the IOCTL codes
//
// IOCTL_XX_GET_MAX_BUFFER_SIZE
//						 
#pragma pack(4)

typedef struct _XX_BUFFER_SIZE_INFO
{
	ULONG MaxWriteLength;
	ULONG MaxReadLength;
} XX_BUFFER_SIZE_INFO, *PXX_BUFFER_SIZE_INFO;

#pragma pack ()


#endif // __XX_IOCTL__

