// File Name:
//		xxdriver.h
//
// Contents:
//		Constants, structures, and function
//		declarations specific to this driver.
//
#ifndef __XX_DRIVER__
#define __XX_DRIVER__

//
// Header files
//
#include <ntddk.h>

//
// Various constants
//
#define	XX_NT_DEVICE_NAME		L"\\Device\\Xx0"
#define	XX_WIN32_DEVICE_NAME	L"\\DosDevices\\XX1"
#define	XX_DRIVER_NAME			L"XXDRIVER"

//++
// Description:
//		Driver-defined structure used to hold 
//		miscellaneous device information.
//
// Access:
//		Allocated from NON-PAGED POOL
//		Available at any IRQL
//--
typedef struct _DEVICE_EXTENSION 
{
	PDEVICE_OBJECT DeviceObject; // Back pointer
	
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;


//
// Prototypes for globally defined functions...
//
//
// init.c
//
NTSTATUS
DriverEntry(
	IN PDRIVER_OBJECT DriverObject,
	IN PUNICODE_STRING RegistryPath
	);

//
// unload.c
//
VOID
XxDriverUnload(
	IN PDRIVER_OBJECT DriverObject
	);

//
// dispatch.c
//
NTSTATUS
XxDispatchCreateClose(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp
	);

#endif	// __XX_DRIVER__

