#include <windows.h>
#include <stdio.h>

//
// Forward declarations of local functions...
//
static VOID
ErrorMessage( 
	LPTSTR lpOrigin, 
	DWORD dwMessageId
	);

//
// Main entry point...
//
VOID __cdecl
main( 
	VOID 
	)
{
	HANDLE hDevice;
	DWORD dwErrorCode;
	DWORD dwBytesWritten;
	LPTSTR Buffer = "The owls are not what they seem.\n";

	//
	// Get a handle to the device...
	//
	hDevice = CreateFile(
				"\\\\.\\CRASH1",
				GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL );
	if( hDevice == INVALID_HANDLE_VALUE )
	{
		dwErrorCode = GetLastError();
		ErrorMessage( "CreateFile", dwErrorCode );
		ExitProcess( dwErrorCode );
	}

	//
	// Do some output...
	//
	if( !WriteFile(
			hDevice,
			Buffer,
			strlen( Buffer ),
			&dwBytesWritten,
			NULL ))
	{
		dwErrorCode = GetLastError();
		ErrorMessage( "WriteFile", dwErrorCode );
		ExitProcess( dwErrorCode );
	}

	printf( 
		"Success ! %d bytes written\n", 
		dwBytesWritten );

	//
	// All done...
	//
	CloseHandle( hDevice );
	ExitProcess( ERROR_SUCCESS );
}


//
// This helper routine converts a system-service error
// code into a text message and prints it on StdOutput
//
static VOID
ErrorMessage( 
	LPTSTR lpOrigin,	// Indicates error location
	DWORD dwMessageId	// ERROR_XXX code value
	)
{
	LPTSTR msgBuffer;		// string returned from system
	DWORD cBytes;			// length of returned string

	cBytes = FormatMessage(
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_ALLOCATE_BUFFER,
				NULL,
				dwMessageId,
				MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),
				(TCHAR *)&msgBuffer,
				500,
				NULL );
	if( msgBuffer )
	{
		msgBuffer[ cBytes ] = TEXT('\0');
		printf( "Error: %s -- %s\n", lpOrigin, msgBuffer );
		LocalFree( msgBuffer );
	}
	else 
	{
		printf( "FormatMessage error: %d\n", GetLastError());
	}
}
