//++
// File Name:
//		data.c
//
// Contents:
//		This file defines the static portions
//		of the data returned by the collection DLL.
//--

//
// All-inclusive header file
//
#include "xxperf.h"

//
//  Constant structure initializations 
//
XX_HEADER_DEFINITION XxObjectHeader =
{
	//
	// PERF_OBJECT_TYPE for XxDevice
	//
	{
		XX_OBJECT_DATA_SIZE,
		sizeof(XX_HEADER_DEFINITION),
		sizeof(PERF_OBJECT_TYPE),
		XXDEVICE,
		NULL,
		XXDEVICE,
		NULL,
		PERF_DETAIL_NOVICE,
		XX_NUM_COUNTERS,
		 0,	
		PERF_NO_INSTANCES,
		 0	
	},

	//
	// PERF_COUNTER_DEFINITION for the
	// interrupt/sec counter
	//
	{
		sizeof(PERF_COUNTER_DEFINITION),
		INTERRUPTS,
		NULL,
		INTERRUPTS,
		NULL,
		0,
		PERF_DETAIL_NOVICE,
		PERF_COUNTER_COUNTER,
		sizeof(DWORD),
		XX_INTERRUPTS_OFFSET
	},
    
	//
	// PERF_COUNTER_DEFINITION for the
	// operation/sec counter.
	//
	{
		sizeof(PERF_COUNTER_DEFINITION),
		OPERATIONS,
		NULL,
		OPERATIONS,
		NULL,
		0,
		PERF_DETAIL_NOVICE,
		PERF_COUNTER_COUNTER,
		sizeof(DWORD),
		XX_OPERATIONS_OFFSET
	}
};

