// File Name:
//		data.h
//
// Contents:
//		Constants, structures, and function
//		declarations specific to this DLL.
//
#ifndef __DATA__
#define __DATA__

#ifndef __XX_IOCTL__
#include "xxioctl"		// Defines XX_PERF_DATA struct
#endif

#pragma pack(4)

//
// Data definition for the counters maintained by
// XXDRIVER
//
typedef struct _XX_HEADER_DEFINITION
{
	PERF_OBJECT_TYPE XxDevice;
	PERF_COUNTER_DEFINITION	Interrupts;
	PERF_COUNTER_DEFINITION	Operations;
} XX_HEADER_DEFINITION, *PXX_HEADER_DEFINITION;


//
// Miscellaneous beautification symbols
//
#define XX_OBJECT_DATA_SIZE				\
((sizeof( XX_HEADER_DEFINITION )) +		\
 (sizeof( XX_PERF_DATA )))

#define XX_NUM_COUNTERS					\
(((sizeof( XX_HEADER_DEFINITION ))		\
	- (sizeof(PERF_OBJECT_TYPE)))		\
/ (sizeof(PERF_COUNTER_DEFINITION)))

#define XX_INTERRUPTS_OFFSET			\
(sizeof( PERF_COUNTER_BLOCK ))

#define XX_OPERATIONS_OFFSET			\
(XX_INTERRUPTS_OFFSET + sizeof( DWORD ))

#pragma pack ()

#endif	// __DATA__

