// File Name:
//		xxperf.h
//
// Contents:
//		Constants, structures, and function
//		declarations specific to this DLL.
//
#ifndef __XX_PERF__
#define __XX_PERF__

//
// Header files
//
#include <windows.h>
#include <string.h>
#include <wchar.h>
#include <winioctl.h>
#include <winperf.h>

#include "xxioctl.h"
#include "counters.h"
#include "messages.h"
#include "data.h"

//
// Various constants
//
#define	XX_DRIVER_NAME			"XXDRIVER"
#define XX_WIN32_DEVICE_NAME	"\\\\.\\XX1"
#define	XX_EVENT_LOG_KEY		"xxperf"

#define XX_NUM_OBJECT_TYPES		1

//
// Error-logging verbosity levels
//
#define LOG_LEVEL_NONE			0
#define LOG_LEVEL_NORMAL		1
#define LOG_LEVEL_DEBUG_MIN		2
#define LOG_LEVEL_DEBUG_MAX		3

#define  DEFAULT_LOG_LEVEL	LOG_LEVEL_DEBUG_MAX

//
// Collection query-types
//
#define PERF_QUERY_TYPE_COSTLY		1
#define PERF_QUERY_TYPE_FOREIGN		2
#define PERF_QUERY_TYPE_GLOBAL		3
#define PERF_QUERY_TYPE_ITEMS		4

//
// Prototypes for globally defined functions...
//
//
// eventlog.c
//
VOID
XxOpenEventLog(
	VOID
	);

VOID
XxCloseEventLog(
	VOID
	);

VOID
XxLogInformation(
	IN DWORD dwMessageLevel,
	IN DWORD dwMessage
	);

VOID
XxLogError(
	IN DWORD dwMessageLevel,
	IN DWORD dwMessage
	);

VOID
XxLogErrorWithData(
	IN DWORD	dwMessageLevel,
	IN DWORD	dwMessage,
	IN LPDWORD	lpdwDumpData,
	IN DWORD	cbDumpDataSize
	);

//
// parse.c
//
DWORD
XxGetPerfQueryType(
    IN LPWSTR lpValue
	);

BOOL
XxIsNumberInList(
    IN DWORD   dwNumber,
    IN LPWSTR  lpwszUnicodeList
	);

#endif // __XX_PERF__



