/******************************************************************************
*                                                                                                                          *
* Copyright 1993 Adaptec, Inc.,  All Rights Reserved.                         *
*                                                                                                                          *
* This software contains the valuable trade secrets of Adaptec.  The             *
* software is protected under copyright laws as an unpublished work of        *
* Adaptec.  Notice is for informational purposes only and does not imply      *
* publication.  The user of this software may make copies of the software     *
* for use with parts manufactured by Adaptec or under license from Adaptec    *
* and for no other use.                                                                                *
*                                                                                                                          *
******************************************************************************/

/******************************************************************************
*
*  Driver Name:  ASPIAPP.EXE
*
*  Version:       1.0
*
*  Source Code:  ASPIAPP.C ASPI.H MAKEFILE
*
*  Base Code #:  537806-00
*
*  Description:  This application, ASPIAPP.EXE is a sample application that
*    sends SRBs to OS2ASPI.DMD via the device driver ASPIDRV.SYS.
*
*                 - This is a simple full screen text application that scans for
*         SCSI adapters and displays information about all targets that
*         are found.
*
*  History:
*
*     06/24/93 - JHL - v1.0 submitted.
*
******************************************************************************/
#define INCL_DOSDEVICES
#include <os2def.h>
#include <bse.h>
#include <mem.h>
#include <alloc.h>
#include <stdio.h>
#include <string.h>
#include "aspi.h"

#define ASPI_REQ  0x80
#define MAX_CDB_LENGTH 12
#define MAX_SENSE_LENGTH 18

void main()

   {
   HFILE aspiDriverHandle;
   ULONG action;
   USHORT currentAdapter;
   USHORT currentTarget;
   ASPI_SRB_INQUIRY inquirySRB;
   ASPI_SRB_DEVICE_TYPE deviceSRB;
   PASPI_SRB_EXECUTE_IO executeSRB;
   UCHAR inquiryData[50];
   UCHAR inquiryOutput[20];
   UCHAR *adapterString = "Adapter:";
   UCHAR *targetString = "Target:";
   UCHAR *deviceString = "Device Type:";
   UCHAR *noDriver = "Driver NOT found";
   UCHAR *SRBError = "Error executing SRB";
   UCHAR *vendorInformation = "Device Name:";
   //Attempt to open the driver for calls to OS2ASPI.DMD
   if (DosOpen((PSZ)"ASPIDRV$",
			 (PHFILE) &aspiDriverHandle,
			(PULONG) &action,
			0L,
			0L,
			FILE_OPEN,
			OPEN_SHARE_DENYNONE | OPEN_FLAGS_FAIL_ON_ERROR | OPEN_ACCESS_READWRITE,
			0L))
      printf("%s\n",noDriver);
   else
      {
      //Initialize the SRB
      memset(&inquirySRB,
	     0,
	     sizeof(inquirySRB));

      //The driver was opened, so send a command to it
      DosDevIOCtl(aspiDriverHandle,           // DevHandle
		   ASPI_REQ,                  // ulCategory
			   ASPI_CMD_ADAPTER_INQUIRY,    // ulFunction
			   (PCHAR) &inquirySRB,       // pParmList
		   sizeof(inquirySRB),        // ulParmLengthMax
			   NULL,                              // pParmLengthInOut
			   NULL,                                       // pDataArea
			    0,                                    // ulDataLengthMax
			    NULL);                             // pDataLengthInOut

      // If some adapters were found, display their targets
      if ((inquirySRB.SRBHdr.ASPIStatus == ASPI_STATUS_NO_ERROR) &&
	       (inquirySRB.AdapterCount))
	      {
	      for (currentAdapter = 0; currentAdapter < inquirySRB.AdapterCount; currentAdapter++)
		      {
		      for (currentTarget = 0; currentTarget < 8; currentTarget++)
			      {
			      //Initialize the SRB 
	       memset(&deviceSRB,
		      0,
		      sizeof(deviceSRB));
			     
	       deviceSRB.SRBHdr.CommandCode = ASPI_CMD_GET_DEVICE_TYPE;
			      deviceSRB.SRBHdr.AdapterIndex = currentAdapter;
			      deviceSRB.DeviceTargetID = currentTarget;

			      DosDevIOCtl(aspiDriverHandle,           // DevHandle
					       ASPI_REQ,                      // ulCategory
					   ASPI_CMD_GET_DEVICE_TYPE,  // ulFunction
					       (PCHAR) &deviceSRB,            // pParmList
					       sizeof(deviceSRB),             // ulParmLengthMax
					       NULL,                              // pParmLengthInOut
					       NULL,                              // pDataArea
					       0,                                         // ulDataLengthMax
					       NULL);                          // pDataLengthInOut

			      // If the target was found, issue an INQUIRY and display
	       // the results.
			      if (deviceSRB.SRBHdr.ASPIStatus == ASPI_STATUS_NO_ERROR)
				      {
				      printf("%s %d %s %d %s %d ", 
			 adapterString,
							    currentAdapter,
							    targetString,
							    currentTarget,
							    deviceString,
							    deviceSRB.DeviceType);

				 //Initialize the SRB
		  executeSRB = malloc(sizeof(ASPI_SRB_EXECUTE_IO) + 
				      MAX_CDB_LENGTH + 
				      MAX_SENSE_LENGTH);

		  memset(executeSRB,
			 0,
			 (sizeof(ASPI_SRB_EXECUTE_IO) + 
				      MAX_CDB_LENGTH + 
				      MAX_SENSE_LENGTH));

		  //Set up the SRB, and pass the data buffer pointer as 
		  //part of the IOCtl
				 executeSRB->SRBHdr.CommandCode = ASPI_CMD_EXECUTE_IO;
		  executeSRB->SRBHdr.ASPIReqFlags = ASPI_REQFLAG_DIR_TO_HOST | 
						    ASPI_REQFLAG_POST_ENABLE;
				 executeSRB->SRBHdr.AdapterIndex = currentAdapter;
				 executeSRB->DeviceTargetID = currentTarget;
		  executeSRB->DataXferLen = 50;
			    executeSRB->SenseDataLen = MAX_SENSE_LENGTH;
		  executeSRB->SCSICDBLen = 6;
		  executeSRB->SCSICDBStart[0] = 0x12;
		  executeSRB->SCSICDBStart[4] = 50;

				 DosDevIOCtl(aspiDriverHandle,                // DevHandle
						  ASPI_REQ,                   // ulCategory
					      ASPI_CMD_EXECUTE_IO,       // ulFunction
						  (PCHAR) executeSRB,         // pParmList
						  (sizeof(ASPI_SRB_EXECUTE_IO) + 
				      MAX_CDB_LENGTH + 
				      MAX_SENSE_LENGTH), // ulParmLengthMax
						  NULL,                           // pParmLengthInOut
						  (PCHAR) inquiryData,       // pDataArea
						  sizeof(inquiryData),       // ulDataLengthMax
						  NULL);                               // pDataLengthInOut

		  // If the command completed, display the data
		  if (executeSRB->SRBHdr.ASPIStatus == ASPI_STATUS_NO_ERROR)
		     {
		     strncpy(inquiryOutput,inquiryData + 8,19);
		     inquiryOutput[19] = '\0';
		     printf("%s %s\n",vendorInformation,inquiryOutput);
		     }
		  else
		     printf("%s\n",SRBError);

		  free(executeSRB);
				      }
			      }
		      }
	      }
      DosClose(aspiDriverHandle);
      }
   }

