vs50stan.sp 5 Megatransfers ACTIVE NEGATION nominal scsi pad  

* 5/16/96 

********************************************************************

* REMAINDER OF SCSI BUS MODEL

* TRANSMISSION LINE, DEVICE LOADS AND TERMINATION MODELS 

********************************************************************

* SLEW RATE TEST CIRCUIT

* COMMENT THIS SECTION OUT IF TERMINATION IS NOT WANTED OR NEEDED,
* OR REPLACE THIS WITH ANOTHER TERMINATOR MODEL

VTERM TERM   VSS   2.5
RTERM TERM2  PAD   47
LTERM TERM2  TERM  5n

********************************************************************

* OPTIONS

.OPTION RELTOL=.001 ABSTOL=1E-12 VNTOL=.1U
.OPTION ABSMOS=1E-9 NUMDGT=4
.OPTION RELMOS=.001 METHOD=GEAR LVLTIM=2
.OPTION ITL1=500
.OPTION ITL2=500
.OPTION ITL3=100
.OPTION ITL4=100
.OPTION ITL5=100000
.option post=1

********************************************************************

* PARAMETERS

.param VDD=5.0
.TEMP=25
.param TRAN=200n

********************************************************************

* SUPPLIES AND STIMULI

VDD   VDD  0 VDD

VPU PUX 0 PULSE(0 VDD 0n 7n 8n 96n 200n)

VPD PDX 0 PWL(0n VDD 1n 4.5 2n 4 4n 2.5 8n 1.5 10n 1 13n .6 15n .5 20n .3 24n 0
+ 93n 0 98n .2 99n .5 100n .75 101n 1 102n 1.25 105n 2 107n 2.5 
+ 108n 2.75 109n 3.5 111n VDD 200n VDD) R 

MNPU VDD2 PUX PAD2 VSS N W=200U  L=8U
MNPD PAD2 PDX VSS  VSS N W=2100U L=24U m=4

LPAD    PAD     PAD2    5n
LVDD    VDD     VDD2    5n
LVSS    VSS     0       5n

RINT  PAD2   DATAI 240
CINT  DATAI  VSS   95f
CL    PAD    0     20p

.TRAN 0.01n TRAN

********************************************************************

* MODELS 

.protect
.lib 'c7_hsp47.skw' mask_stuff
.lib 'c7_hsp47.skw' process_stuff
.lib 'c7_hsp47.skw' nom 
.lib 'c7_hsp47.skw' device_stuff
.unprotect

********************************************************************

* MEASUREMENTS

.measure tran trise trig v(pad) val=1 rise=1 targ v(pad) val=2 rise=1
.measure tran tfall trig v(pad) val=2 td=20n fall=1 targ v(pad) val=1 fall=1
.measure tran SRPLUS  param='(1/trise)*1E-9'
.measure tran SRMINUS param='(1/tfall)*1E-9'

*********************************************************************

.end
